// -------------------------------------------------------------------------------
// 
// 		cwCu		`vOwb_t@C
// 
// 				Ver 3.14c
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICS_H__
#define __DXGRAPHICS_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxHandle.h"
#include "DxMemImg.h"
#include "DxMovie.h"
#include "DxArchive_.h"
#include "DxBaseImage.h"
#include <stdarg.h>

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define GSYS						GraphicsSysData
#define MASKD						MaskManageData

// L^ĂLɂȂĂ郉Cg̃CfbNX̐
#define MAX_HARDWAREENABLELIGHTINDEX_NUM	(256)

// ɕ`ł郌_O^[Qbg̍ő吔
#define DX_RENDERTARGET_COUNT				(8)

// gpeNX`Xe[W̍ő吔
#define USE_TEXTURESTAGE_NUM				(16)

// ɓKpłVhE}bv̍ő吔
#define MAX_USE_SHADOWMAP_NUM				(3)

// Lobt@̐
#define COMMON_BUFFER_NUM					(3)

// _^Cv
#define VERTEXTYPE_NOTEX					(0)			// eNX`gpȂ
#define VERTEXTYPE_TEX						(1)			// eNX`gp
#define VERTEXTYPE_BLENDTEX					(2)			// uheNX`gp
#define VERTEXTYPE_NUM						(3)

// OtBbNnh̗L`FbN
#define GRAPHCHKFULL( HAND, GPOINT )			HANDLECHKFULL(       DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHKFULL_ASYNC( HAND, GPOINT )		HANDLECHKFULL_ASYNC( DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHK( HAND, GPOINT )				HANDLECHK(           DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHK_ASYNC( HAND, GPOINT )			HANDLECHK_ASYNC(     DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )

// VhE}bvnh̗L`FbN
#define SHADOWMAPCHKFULL( HAND, SPOINT )		HANDLECHKFULL(       DX_HANDLETYPE_SHADOWMAP, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADOWMAPCHKFULL_ASYNC( HAND, SPOINT )	HANDLECHKFULL_ASYNC( DX_HANDLETYPE_SHADOWMAP, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADOWMAPCHK( HAND, SPOINT )			HANDLECHK(           DX_HANDLETYPE_SHADOWMAP, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADOWMAPCHK_ASYNC( HAND, SPOINT )		HANDLECHK_ASYNC(     DX_HANDLETYPE_SHADOWMAP, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// VF[_[nh̗L`FbN
#define SHADERCHK( HAND, SPOINT )				HANDLECHK(       DX_HANDLETYPE_SHADER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADERCHK_ASYNC( HAND, SPOINT )			HANDLECHK_ASYNC( DX_HANDLETYPE_SHADER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// VF[_[p萔obt@nh̗L`FbN
#define SHADERCONSTANTBUFFERCHK( HAND, SPOINT )				HANDLECHK(       DX_HANDLETYPE_SHADER_CONSTANT_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADERCONSTANTBUFFERCHK_ASYNC( HAND, SPOINT )		HANDLECHK_ASYNC( DX_HANDLETYPE_SHADER_CONSTANT_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// _obt@nh̗L`FbN
#define VERTEXBUFFERCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_VERTEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define VERTEXBUFFERCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_VERTEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// CfbNXobt@nh̗L`FbN
#define INDEXBUFFERCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_INDEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define INDEXBUFFERCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_INDEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// yobt@tH[}bg
#define ZBUFFER_FORMAT_16BIT		(0)
#define ZBUFFER_FORMAT_24BIT		(1)
#define ZBUFFER_FORMAT_32BIT		(2)
#define ZBUFFER_FORMAT_NUM			(3)

// `ݒ^Cv
#define DX_DRAWSETTING_2D			(0)			// ʏ̂Qc`p̐ݒ
#define DX_DRAWSETTING_SHADER		(1)			// VF[_[g`p̐ݒ
#define DX_DRAWSETTING_MASK			(2)			// }XNp̐ݒ
#define DX_DRAWSETTING_TOONOUTLINE	(3)			// gD[_Of̗֊s`p̐ݒ
#define DX_DRAWSETTING_MODEL		(4)			// f`p̐ݒ
#define DX_DRAWSETTING_NUM			(5)			// `ݒ^Cv̐

// VF[_[萔Zbg
#define DX_SHADERCONSTANTSET_LIB			0
#define DX_SHADERCONSTANTSET_LIB_SUB		1
#define DX_SHADERCONSTANTSET_MV1			2
#define DX_SHADERCONSTANTSET_USER			3
#define DX_SHADERCONSTANTSET_NUM			4

// VF[_[萔^Cv
#define DX_SHADERCONSTANTTYPE_VS_FLOAT		0
#define DX_SHADERCONSTANTTYPE_VS_INT		1
#define DX_SHADERCONSTANTTYPE_VS_BOOL		2
#define DX_SHADERCONSTANTTYPE_PS_FLOAT		3
#define DX_SHADERCONSTANTTYPE_PS_INT		4
#define DX_SHADERCONSTANTTYPE_PS_BOOL		5
#define DX_SHADERCONSTANTTYPE_NUM			6

// }XN^
#ifdef DX_NON_MASK
#define MASK_FULLSCREEN_MASKUPDATE
#else
#define MASK_FULLSCREEN_MASKUPDATE					\
	if( MASKD.FullScreenMaskUpdateFlag )			\
	{												\
		RECT MaskRect ;								\
		MaskRect.left   = GSYS.DrawSetting.DrawArea.left ;		\
		MaskRect.right  = GSYS.DrawSetting.DrawArea.right ;	\
		MaskRect.top    = GSYS.DrawSetting.DrawArea.top ;		\
		MaskRect.bottom = GSYS.DrawSetting.DrawArea.bottom ;	\
		MASK_END( MaskRect )						\
		MASKD.FullScreenMaskUpdateFlag = FALSE ;	\
	}
#endif

// `͈͂ɓĂ邩ǂ̔( 0 `̈ɓĂȂ )
#define IN_DRAWAREA_CHECK( x1, y1, x2, y2 )	\
		( (DWORD)( ( (x2) - ( GSYS.DrawSetting.DrawArea.right  + 1 ) ) & ( GSYS.DrawSetting.DrawArea.left - ( (x1) + 1 ) ) &					\
		           ( (y2) - ( GSYS.DrawSetting.DrawArea.bottom + 1 ) ) & ( GSYS.DrawSetting.DrawArea.top  - ( (y1) + 1 ) ) ) & 0x80000000 )

// `͈͂犮SɊOĂ邩ǂ̔( 0 Ȃ犮Sɂ͂Ă )
#define OUT_DRAWAREA_CHECK( x1, y1, x2, y2 ) \
		( (DWORD)( ( GSYS.DrawSetting.DrawArea.right  - ( (x1) + 1 ) ) & ( (x2) - ( GSYS.DrawSetting.DrawArea.left + 1 ) ) &		\
		           ( GSYS.DrawSetting.DrawArea.bottom - ( (y1) + 1 ) ) & ( (y2) - ( GSYS.DrawSetting.DrawArea.top  + 1 ) ) ) & 0x80000000 )

#define DRAWRECT_DRAWAREA_CLIP\
		if( IN_DRAWAREA_CHECK( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) == 0 )\
		{\
			if( DrawRect.left   < GSYS.DrawSetting.DrawArea.left   ) DrawRect.left   = GSYS.DrawSetting.DrawArea.left   ;\
			if( DrawRect.right  < GSYS.DrawSetting.DrawArea.left   ) DrawRect.right  = GSYS.DrawSetting.DrawArea.left   ;\
			if( DrawRect.left   > GSYS.DrawSetting.DrawArea.right  ) DrawRect.left   = GSYS.DrawSetting.DrawArea.right  ;\
			if( DrawRect.right  > GSYS.DrawSetting.DrawArea.right  ) DrawRect.right  = GSYS.DrawSetting.DrawArea.right  ;\
			if( DrawRect.top    < GSYS.DrawSetting.DrawArea.top    ) DrawRect.top    = GSYS.DrawSetting.DrawArea.top    ;\
			if( DrawRect.bottom < GSYS.DrawSetting.DrawArea.top    ) DrawRect.bottom = GSYS.DrawSetting.DrawArea.top    ;\
			if( DrawRect.top    > GSYS.DrawSetting.DrawArea.bottom ) DrawRect.top    = GSYS.DrawSetting.DrawArea.bottom ;\
			if( DrawRect.bottom > GSYS.DrawSetting.DrawArea.bottom ) DrawRect.bottom = GSYS.DrawSetting.DrawArea.bottom ;\
		}

#ifdef DX_NON_MASK
#define MASK_BEGIN( RECT )
#else
#define MASK_BEGIN( RECT )		if( MASKD.MaskValidFlag ) Mask_DrawBeginFunction( (RECT) ) ;
#endif

#ifdef DX_NON_MASK
#define MASK_END( RECT )
#else
#define MASK_END( RECT )		if( MASKD.MaskValidFlag ) Mask_DrawAfterFunction( (RECT) ) ;
#endif

// `^
#ifdef DX_NON_2DDRAW
	#ifdef DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_SUB && GSYS.HardInfo.ValidSubBlend == FALSE )\
				{\
					RECT DrawRect ;\
					SETRECT\
					Graphics_DrawSetting_BlendModeSub_Pre( &DrawRect ) ;\
					RET = (FUNC3D) ;\
					Graphics_DrawSetting_BlendModeSub_Post( &DrawRect ) ;\
				}\
				else\
				{\
					RET = (FUNC3D) ;\
				}\
			}
	#else // DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				bool UseSubMode = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_SUB && GSYS.HardInfo.ValidSubBlend == FALSE ;\
				if( UseSubMode || MASKD.MaskValidFlag )\
				{\
					RECT DrawRect ;\
					SETRECT\
					MASK_BEGIN( DrawRect ) ;\
					if( UseSubMode )\
					{\
						Graphics_DrawSetting_BlendModeSub_Pre( &DrawRect ) ;\
						RET = (FUNC3D) ;\
						Graphics_DrawSetting_BlendModeSub_Post( &DrawRect ) ;\
					}\
					else\
					{\
						RET = (FUNC3D) ;\
					}\
					\
					MASK_END( DrawRect ) ;\
				}\
				else\
				{\
					RET = (FUNC3D) ;\
				}\
			}
	#endif // DX_NON_MASK
#else // DX_NON_2DDRAW
	#ifdef DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_SUB && GSYS.HardInfo.ValidSubBlend == FALSE && (USE3DFLAG) )\
				{\
					RECT DrawRect ;\
					SETRECT\
					Graphics_DrawSetting_BlendModeSub_Pre( &DrawRect ) ;\
					RET = (FUNC3D) ;\
					Graphics_DrawSetting_BlendModeSub_Post( &DrawRect ) ;\
				}\
				else\
				{\
					RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
				}\
			}
	#else // DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				bool UseSubMode = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_SUB && GSYS.HardInfo.ValidSubBlend == FALSE && (USE3DFLAG) ;\
				if( UseSubMode || MASKD.MaskValidFlag )\
				{\
					RECT DrawRect ;\
					SETRECT\
					MASK_BEGIN( DrawRect ) ;\
					if( UseSubMode )\
					{\
						Graphics_DrawSetting_BlendModeSub_Pre( &DrawRect ) ;\
						RET = (FUNC3D) ;\
						Graphics_DrawSetting_BlendModeSub_Post( &DrawRect ) ;\
					}\
					else\
					{\
						RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
					}\
					\
					MASK_END( DrawRect ) ;\
				}\
				else\
				{\
					RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
				}\
			}
	#endif // DX_NON_MASK
#endif // DX_NON_2DDRAW

// `ҋ@Ă钸_⃂f`悷
#ifndef DX_NON_MODEL
	#define MV1DRAWPACKDRAWMODEL		if( MV1Man.PackDrawModel != NULL ) MV1DrawPackDrawModel() ;
#else	// DX_NON_MODEL
	#define MV1DRAWPACKDRAWMODEL
#endif	// DX_NON_MODEL

#define DRAWSTOCKINFO_ASYNC( ASYNCFLAG )	\
	Graphics_Hardware_RenderVertex( ASYNCFLAG ) ;	\
	MV1DRAWPACKDRAWMODEL

#define DRAWSTOCKINFO			\
	Graphics_Hardware_RenderVertex() ;	\
	MV1DRAWPACKDRAWMODEL


// \̒` --------------------------------------------------------------------

// Cuŕ`ΏۂύXۂ̃JȂǂ̐ݒۑĂ߂̍\
typedef struct tagSCREENDRAWSETTINGINFO
{
	int						Use3DFlag ;
	int						UseSysMemFlag ;
	int						DrawMode ;
	int						WaitVSync ;
	int						DrawScreen ;
	MATRIX_D				ViewMatrix ;
	MATRIX_D				ProjectionMatrix ;
	MATRIX_D				ViewportMatrix ;
	MATRIX_D				WorldMatrix ;
	int						ProjectionMatrixMode ;
	double					ProjFov ;
	double					ProjSize ;
	double					ProjNear ;
	double					ProjFar ;
	double					ProjDotAspect ;
	MATRIX_D				ProjMatrix ;
	RECT					DrawRect ;
} SCREENDRAWSETTINGINFO ;

// Graphics_Draw_DrawSimpleTwoTriangleGraphF p\
typedef struct tagGRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_VERTEX
{
	float					x, y, u, v ;
} GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_VERTEX ;
typedef struct tagGRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_PARAM
{
	GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_VERTEX Vertex[ 4 ] ;
	int						GraphHandle ;
	int						TransFlag ;
} GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_PARAM ;

// Qc`p_\(eNX`)
typedef struct tagVERTEX_NOTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	unsigned int			color ;
} VERTEX_NOTEX_2D, *LPVERTEX_NOTEX_2D ; 

// ɂQc`Ɏgp钸_f[^^
typedef struct tagVERTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	unsigned int			color ;
	float					u, v ;
} VERTEX_2D, *LPVERTEX_2D ; 

// uh摜tQc摜`p_\
struct VERTEX_BLENDTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	unsigned int			color ;
	unsigned int			specular ;
	float					u1, v1 ;
	float					u2, v2 ;
} ;

// Rc`Ɏgp钸_f[^^( eNX`Ȃ )( o[Ŵ )
typedef struct tagVERTEX_NOTEX_3D
{
	VECTOR					pos ;
	unsigned char			b, g, r, a ;
} VERTEX_NOTEX_3D, *LPVERTEX_NOTEX_3D ;

// \tgEGA_OpIWi摜
struct IMAGEDATA_ORIG_SOFT
{
	MEMIMG					MemImg ;						// MEMIMG
	MEMIMG					*ZBuffer ;						// ZBuffer
} ;

// n[hEGA_OpIWi摜eNX`
struct IMAGEDATA_ORIG_HARD_TEX
{
	struct IMAGEDATA_ORIG_HARD_TEX_PF	*PF ;				// ˑf[^
	int						OrigPosX, OrigPosY ;			// 摜ŎgpĂ̈̍W
	int						UseWidth, UseHeight ;			// 摜ŎgpĂ̈̃TCY
	int						TexWidth, TexHeight ;			// eNX`̂̕ƍ
} ;

// n[hEGA_OpIWi摜
struct IMAGEDATA_ORIG_HARD
{
	int						MipMapCount ;					// ~bv}bv̐
	int						TexNum ;						// eNX`̐
	IMAGEDATA_ORIG_HARD_TEX Tex[ 4 ] ;						// eNX`Xgւ̃|C^
} ;

// IWi摜\
struct IMAGEDATA_ORIG
{
	int						RefCount ;						// QƂĂ鐔
	int						ColorFormat ;					// J[tH[}bg( DX_GRAPHICSIMAGE_FORMAT_3D_RGB16  )
	IMAGEFORMATDESC			FormatDesc ;					// tH[}bg
	unsigned int			TransCode ;						// ߐFR[h
	int						Width, Height ;					// 摜̃TCY
	int						ZBufferFlag ;					// yobt@邩ǂ( TRUE:  FALSE:Ȃ )
	int						ZBufferBitDepthIndex ;			// yobt@rbg[xCfbNX

	union
	{
		IMAGEDATA_ORIG_SOFT	Soft ;						// \tgEGA_Op
		IMAGEDATA_ORIG_HARD	Hard ;						// n[hEGA_Op
	} ;
} ;

// \tgEGA_OŃC[Wf[^\
struct IMAGEDATA_SOFT
{
	MEMIMG					MemImg ;						// `p MEMIMG
} ;

// n[hEGA_OōW\
struct IMAGEDATA_HARD_VERT
{
	float					x, y ;							// ʒu
	float					u, v ;							// tuʒu
} ;

// n[hEGA_Oŕ`p\
struct IMAGEDATA_HARD_DRAW
{
	int						DrawPosX, DrawPosY ;			// `掞Ɏw肳W̑΍W
	int						UsePosX, UsePosY ;				// eNX`ŎgpĂ`̍W
	int						Width, Height ;					// eNX`ŎgpĂTCY

	IMAGEDATA_HARD_VERT		Vertex[ 4 ] ;					// eNX`̕`W
	unsigned char			VertType[ 4 ] ;					// _^Cv( TRUE=Op̔@FALSE= )

	IMAGEDATA_ORIG_HARD_TEX *Tex ;							// gpeNX`ւ̃|C^
} ;

// n[hEGA_OŃC[Wf[^\
struct IMAGEDATA_HARD
{
	int						DrawNum ;						// `p̐
	IMAGEDATA_HARD_DRAW		Draw[ 4 ] ;						// `p
} ;

// C[Wf[^\
struct IMAGEDATA_READBASE
{
	int						Type ;							// ^Cv( 0:t@C 1:C[W 2:BaseImage )

	wchar_t					*FileName ;						// t@C
	BASEIMAGE				*BaseImage ;					// {C[Wf[^
	BASEIMAGE				*AlphaBaseImage ;				// `lp{C[Wf[^
	void					*MemImage ;						// C[W
	int						MemImageSize ;					// C[WTCY
	void					*AlphaMemImage ;				// `lpC[W
	int						AlphaMemImageSize ;				// `lpC[WTCY
	int						ReverseFlag ;					// ]ǂݍ݂ǂ( TRUE:  FALSE:ĂȂ )Aēǂݍ݂̍ۂɓǂݍ݌𔽓]邩ǂŎgpABASEIMAGE ɊւĂ͓ǂݍ݌ۑɔ]邽߂̃tO͖

	int						RefCount ;						// QƐ
} ;

// C[Wf[^\
struct IMAGEDATA
{
	HANDLEINFO				HandleInfo ;					// nhʃf[^

	int						*LostFlag ;						// ɗĂtÕ|C^

#ifndef DX_NON_MOVIE
	int						MovieHandle ;					// nh
#endif

	IMAGEDATA_READBASE		*ReadBase ;						// f[^
	int						UseBaseX, UseBaseY ;			// f[^ŎgpĂ͈͂̍W

	IMAGEDATA_ORIG			*Orig ;							// IWi摜\̂ւ̃|C^( IWi摜ł͂Ȃꍇ NULL )
	int						UseOrigX, UseOrigY ;			// IWi摜̎gpĂ`̍W
	int						Width, Height ;					// IWi摜̎gpĂ`̕ƍ

	DWORD					*FullColorImage ;				// tJ[C[W

	int						LockFlag ;						// bNĂ邩ǂtO
	BYTE					*LockImage ;					// bNɍ쐬e|C[W
	DWORD					LockImagePitch ;				// bNC[W̃sb`

	int						NotInitGraphDelete ;			// InitGraph ō폜Ȃǂ̃tO( TRUE:InitGraphł͍폜Ȃ  FALSE:InitGraphō폜 )

	int						DeviceLostDeleteFlag ;			// foCXXgɍ폜邩ǂ̃tO( TRUE:foCXXgɍ폜  FALSE:foCXXgɍ폜Ȃ )

	union
	{
		IMAGEDATA_SOFT		Soft ;							// \tgEGA_Op\̂ւ̃|C^
		IMAGEDATA_HARD		Hard ;							// n[hEGA_Op\̂ւ̃|C^
	} ;
} ;

// VF[_[nhŎgp̍\
struct SHADERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						IsVertexShader ;					// _VF[_[ǂ( TRUE:_VF[_[  FALSE:sNZVF[_[ )
	void					*FunctionCode ;						// VF[_[R[hi[̈ւ̃|C^
	int						FunctionCodeSize ;					// VF[_[R[h̃TCY

	struct SHADERHANDLEDATA_PF 	*PF ;							// ˑf[^
} ;

// VF[_[p萔obt@nhŎgp̍\
struct SHADERCONSTANTBUFFERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	struct SHADERCONSTANTBUFFERHANDLEDATA_PF 	*PF ;					// ˑf[^
} ;

// _obt@nhŎgp̍\
struct VERTEXBUFFERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						Type ;								// _f[^̃^Cv( DX_VERTEXTYPE_NORMAL_3D  )
	int						UnitSize ;							// _f[^ӂ̃oCg
	int						Num ;								// _̐
	void					*Buffer ;							// VXeɊmۂꂽobt@

	struct VERTEXBUFFERHANDLEDATA_PF *PF ;						// ˑf[^
} ;

// CfbNXobt@nhŎgp̍\
struct INDEXBUFFERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						Type ;								// CfbNXf[^̃^Cv( DX_INDEX_TYPE_NORMAL_3D  )
	int						UnitSize ;							// CfbNXf[^ӂ̃oCg
	int						Num ;								// CfbNX̐
	void					*Buffer ;							// VXeɊmۂꂽobt@

	struct INDEXBUFFERHANDLEDATA_PF *PF ;						// ˑf[^
} ;

// VhE}bvf[^\
struct SHADOWMAPDATA
{
	HANDLEINFO				HandleInfo ;					// nhʃf[^

	int						*LostFlag ;						// ɗĂtÕ|C^

	int						TexFormat_Float ;				// _^tH[}bgǂ( TRUE:_^  FALSE:Œ菬_^ )
	int						TexFormat_BitDepth ;			// rbg[x
	int						ColorFormat ;					// J[tH[}bg
	int						ZBufferFormat ;					// yobt@tH[}bg

	int						EnableDrawArea ;				// DrawAreaMinPosition  DrawAreaMaxPosition Lǂ
	VECTOR					DrawAreaMinPosition ;			// VhE}bv̕`̍ۂɓ͈͂̏W
	VECTOR					DrawAreaMaxPosition ;			// VhE}bv̕`̍ۂɓ͈͂̑傫W
	VECTOR					DrawAreaViewClipPos[ 8 ] ;		// VhE}bvɕ`悷͈͂͂ލW

	VECTOR					DefaultViewClipPos[ 8 ] ;		// EnableDrawArea  FALSE ̍ۂɎgpVhE}bvɕ`悷͈͂͂ލW

	int						BaseSizeX ;						// VhE}bṽTCY
	int						BaseSizeY ;

	int						DrawSetupFlag ;					// `揀Ă邩ǂ̃tO

	MATRIX					ShadowMapViewMatrix ;			// VhE}bv`悵ۂ̃r[s
	MATRIX					ShadowMapProjectionMatrix ;		// VhE}bv`悵ۂ̎ˉes
	MATRIX					ShadowMapViewProjectionMatrix ; // VhE}bv`悵ۂ̃r[sƎˉesZ

	float					AdjustDepth ;					// VhE}bvgp`掞̐[x␳l
	int						BlurParam ;						// VhE}bvɓKpڂtB^[̒l
	float					GradationParam ;				// VhE}bvl̃Of[V͈̔

	int						RenderTargetScreen[ DX_RENDERTARGET_COUNT ] ;			// X̃_O^[Qbg
	int						RenderTargetScreenSurface[ DX_RENDERTARGET_COUNT ] ;	// X̃_O^[QbgT[tFX

	int						RenderMaskUseFlag ;				// }XNʂgp邩ǂ̃tO

	VECTOR					LightDirection ;				// VhE}bvz肷郉Cg̕
	MATRIX					LightMatrix ;					// VhE}bvz肷郉Cg̍s

	VECTOR_D				RenderCameraPosition ;			// _Osۂ̃J̈ʒu
	VECTOR_D				RenderCameraTarget ;			// _Osۂ̃J̒_
	VECTOR_D				RenderCameraUp ;				// _Osۂ̃J̃AbvxNg
	double					RenderCameraHRotate ;			// _Osۂ̃J̐px
	double					RenderCameraVRotate ;			// _Osۂ̃J̐px
	double					RenderCameraTRotate ;			// _Osۂ̃J̔Ppx
	MATRIX_D				RenderCameraMatrix ;			// _Osۂ̃r[s
	double					RenderCameraScreenCenterX ;		// _Osۂ̃J̏_
	double					RenderCameraScreenCenterY ;

	int						RenderProjectionMatrixMode ;	// _Osۂ̎ˉes쐬[h
	double					RenderProjNear ;				// _Osۂ̃J NearNbv
	double					RenderProjFar ;					// _Osۂ̃J FarNbv
	double					RenderProjDotAspect ;			// _Osۂ̃hbgAXyNg( c /  )
	double					RenderProjFov ;					// _Osۂ̉ߖ@̎p
	double					RenderProjSize ;				// _Osۂ̐ˉẽTCY
	MATRIX_D				RenderProjMatrix ;				// _Osۂ̎ˉes

	struct SHADOWMAPDATA_PF	*PF ;							// ˑf[^
} ;


// _^ RECT \
struct RECTF
{
	float left, top ;
	float right, bottom ;
} ;

// OtBbNnh̃ZbgAbvɕKvȃO[of[^Z߂\
struct SETUP_GRAPHHANDLE_GPARAM
{
	DWORD					TransColor ;							// ߐF

	int						CreateImageColorBitDepth ;				// 쐬摜̐F[x
	int						CreateImageChannelBitDepth ;			// 쐬摜̂P`lӂ̃rbg[x( 炪ݒ肳Ăꍇ CreateImageColorBitDepth D悳 )
	int						AlphaTestImageCreateFlag ;				// eXgt摜쐬wtO( AlphaGraphCreateFlag ̕Dx )( eNX`T[tFX̂ )
	int						AlphaChannelImageCreateFlag ;			// `lt摜쐬wtO( DrawValidGraphCreateFlag ̕Dx )
	int						CubeMapTextureCreateFlag ;				// L[u}bveNX`쐬wtO( 1:L[u}bveNX`쐬  0:ʏeNX`쐬 )
	int						BlendImageCreateFlag ;					// uhp摜쐬wtO
	int						UseManagedTextureFlag ;					// }l[WheNX`gp邩AtO( 1:gp  0:gpȂ )

	int						DrawValidImageCreateFlag ;				// `\摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidAlphaImageCreateFlag ;			// `\ȃ`lt摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidFloatTypeGraphCreateFlag ;		// `\Float^摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidGraphCreateZBufferFlag ;		// `\摜쐬ۂɐp̂yobt@쐬邩ǂ
	int						CreateDrawValidGraphChannelNum ;		// `\摜̃`l( eNX`T[tFX̂ )
	int						CreateDrawValidGraphZBufferBitDepth ;	// `\摜̂yobt@̃rbg[x( eNX`T[tFX̂ )
	int						DrawValidMSSamples ;					// `\ȉ摜̃}`TvO
	int						DrawValidMSQuality ;					// `\ȉ摜̃}`TvONIeB

	int						MipMapCount ;							// ō쐬~bv}bv̐( -1:ő僌x܂ō쐬 )
	int						UserMaxTextureSize ;					// [U[w̃eNX`őTCY
	int						NotUseDivFlag ;							// 摜sȂǂ( TRUE:sȂ  FALSE:s )
	int						NotUseAlphaImageLoadFlag ;				// _a tAt@`lp̉摜t@CǉœǂݍޏsȂǂ( TRUE:sȂ  FALSE:s )
	int						NotInitGraphDelete ;					// InitGraph ō폜Ȃǂ̃tO( TRUE:InitGraphł͍폜Ȃ  FALSE:InitGraphō폜 )
} ;

// VhE}bvnh̃ZbgAbvɕKvȃO[of[^Z߂\
struct SETUP_SHADOWMAPHANDLE_GPARAM
{
	int						Dummy ;
} ;

// 摜f[^OtBbNnh̍쐬E摜f[^̓]ɕKvȃO[of[^Z߂
struct CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM
{
	SETUP_GRAPHHANDLE_GPARAM InitHandleGParam ;						// OtBbNnh̃ZbgAbvɕKvȃO[of[^

	int						NotUseTransColor;						// ߐFgpȂǂtO(TRUE:gpȂ  FALSE:gp)
	int						UseTransColorGraphCreateFlag ;			// ߐFƂłȂ̋E炩ɂ邩AtO
	int						LeftUpColorIsTransColorFlag ;			// 摜̃sNZF𓧉ߐFɂ邩ǂ̃tO
} ;

// 摜̌f[^̏ɕKvȃO[of[^Z߂
struct SETGRAPHBASEINFO_GPARAM
{
	int						NotGraphBaseDataBackupFlag ;			// OtBbNnh쐬ۂɎgp摜f[^obNAbvȂǂ̃tO( TRUE:obNAbvȂ  FALSE:obNAbv )
} ;

// t@COtBbNnh쐬鏈ɕKvȃO[of[^Z߂
struct LOADGRAPH_GPARAM
{
	LOADBASEIMAGE_GPARAM	LoadBaseImageGParam ;					// 摜f[^̓ǂݍ݂ɕKvȃO[of[^
#ifndef DX_NON_MOVIE
	OPENMOVIE_GPARAM		OpenMovieGParam ;						// [r[t@C̃I[vɕKvȃO[of[^
#endif
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM CreateGraphGParam ;	// OtBbNnh̍쐬EɕKvȃO[of[^
	SETGRAPHBASEINFO_GPARAM	SetGraphBaseInfoGParam ;				// 摜̌f[^̏̕ۑɕKvȃO[of[^
} ;

// OtBbNf[^ǂݍ݈Z߂
struct LOADGRAPH_PARAM
{
	LOADGRAPH_GPARAM		GParam ;
	int						ReCreateFlag ;
	int						GrHandle ;
	int						BaseHandle ;

	const wchar_t *			FileName ;
	const void *			RgbMemImage ;
	int						RgbMemImageSize ;
	const void *			AlphaMemImage ;
	int						AlphaMemImageSize ;
	const BITMAPINFO *		RgbBmpInfo ;
	void *					RgbBmpImage ;
	const BITMAPINFO *		AlphaBmpInfo ;
	void *					AlphaBmpImage ;
	BASEIMAGE *				RgbBaseImage ;
	BASEIMAGE *				AlphaBaseImage ;

	int						AllNum ;
	int						XNum ;
	int						YNum ;
	int						SizeX ;
	int						SizeY ;
	int *					HandleBuf ;
	int						TextureFlag ;
	int						ReverseFlag ;
	int						SurfaceMode ;
} ;

// Cgnh\
struct LIGHT_HANDLE
{
	unsigned int			ID ;												// G[`FbNp̂hc
	int						Handle ;											// g̃nhl

	LIGHTPARAM				Param ;												// Cg̃p[^
	int						SetHardwareIndex ;									// n[hEFAANZ[^̃ZbgĂCfbNX( -1:ZbgĂȂ )
	int						EnableFlag ;										// LtO
	int						HardwareChangeFlag ;								// n[hEFAANZ[^ɔfĂȂݒ肪邩ǂ̃tO( TRUE:  FALSE:Ȃ )
	int						ShadowMapSlotDisableFlag[ MAX_USE_SHADOWMAP_NUM ] ;	// VhE}bvgpȂǂ̃tO( TRUE:gpȂ  FALSE:gp )
} ;

// Cg֌W̍\
struct GRAPHICSSYS_LIGHTATA
{
	int						ProcessDisable ;						// Cg𖳌ɂ邩ǂ
	int						ChangeMaterial ;						// CgvZp}eAύXǂ̃tO
	MATERIALPARAM			Material ;								// CgvZp}eA
	int						MaterialNotUseVertexDiffuseColor ;		// CgvZɒ_̃fBt[YJ[gpȂǂ
	int						MaterialNotUseVertexSpecularColor;		// CgvZɒ_̃XyLJ[gpȂǂ
	LIGHT_HANDLE			*Data[ MAX_LIGHT_NUM ] ;				// Cgւ̃|C^
	int						Num ;									// Cg̐
	int						Area ;									// LȃCg͈
	int						HandleID ;								// CgɊ蓖Ăhc
	int						EnableNum ;								// LɂȂĂ郉Cg̐
	int						MaxHardwareEnableIndex ;				// n[hEFAANZ[^ɑ΂ėLɂȂĂ郉Cgňԑ傫Ȓl̃CfbNX
	int						EnableHardwareIndex[ MAX_HARDWAREENABLELIGHTINDEX_NUM ] ;	// n[hEFAANZ[^ɑ΂ėLɂĂ郉Cg̃Xg
	int						HardwareChange ;						// n[hEFAANZ[^ւ̔fKvȕύXǂ̃tO
	int						HardwareRefresh ;						// n[hEFAANZ[^ւ̑Sڂ̔fKvǂ̃tO
	int						DefaultHandle ;							// ftHgCgpnh
} ;

// J֌W̍\
struct GRAPHICSSYS_CAMERA
{
	VECTOR_D				Position ;								// J̈ʒu
	VECTOR_D				Target ;								// J̒_
	VECTOR_D				Up ;									// J̃AbvxNg
	double					HRotate ;								// J̐px
	double					VRotate ;								// J̐px
	double					TRotate ;								// J̔Ppx
	MATRIX_D				Matrix ;								// r[s
	double					ScreenCenterX ;							// J̏_
	double					ScreenCenterY ;
} ;

// [U[̕`ݒ\
struct GRAPHICSSYS_USERRENDERINFO
{
	int						SetTextureGraphHandle[ 20 ] ;			// [U[ݒ̊eXe[W̃eNX`
	int						SetRenderTargetGraphHandle[ 4 ] ;		// [U[ݒ̊e_O^[Qbg

	int						SetVertexShaderHandle ;					// [U[ݒŎgp钸_VF[_[
	int						SetPixelShaderHandle ;					// [U[ݒŎgpsNZVF[_[
} ;

// `ݒ֌W̍\
struct GRAPHICSSYS_DRAWSETTINGDATA
{
	int						EnableZBufferFlag2D ;					// yobt@̗LtO
	int						WriteZBufferFlag2D ;					// yobt@̍XVsAtO
	int						ZBufferCmpType2D ;						// yl̔r[h
	int						ZBias2D ;								// yoCAX

	int						EnableZBufferFlag3D ;					// yobt@̗LtO
	int						WriteZBufferFlag3D ;					// yobt@̍XVsAtO
	int						ZBufferCmpType3D ;						// yl̔r[h
	int						ZBias3D ;								// yoCAX

	int						NotDrawFlagInSetDrawArea ;				// `s\tOiSetDrawAreapj
	int						UseNoBlendModeParam ;					// DX_BLENDMODE_NOBLEND ł Param ̒lgp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )

//	int						NotUseBasicGraphDraw3DDeviceMethodFlag ;// P}`̕`ɂRcfoCX̋@\gpȂǂ̃tO

	int						FillMode ;								// tB[h( DX_FILL_SOLID Ȃ )
	int						CullMode ;								// JO[h( DX_CULLING_LEFT Ȃ )

	int						TexAddressModeU[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[ht
	int						TexAddressModeV[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hu
	int						TexAddressModeW[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hv

	int						FogEnable ;								// tHOLǂ( TRUE:L  FALSE: )
	int						FogMode ;								// tHO[h
	DWORD					FogColor ;								// tHOJ[
	float					FogStart, FogEnd ;						// tHOJnAhXƏIAhX
	float					FogDensity ;							// tHOx

	float					DrawZ;									// Qc`掞ɂyobt@ɏނyl
	int						DrawMode ;								// `惂[h

	int						MaxAnisotropy ;							// őٕ
	int						Large3DPositionSupport ;				// Rc`ŎgpWl 10000000.0f Ȃǂ̑傫ȒlɂȂĂ`̕}鏈gp邩ǂݒ肷( TRUE:`̕}鏈gp( CPUׂオ܂ )@@FALSE:`̕}鏈͎gpȂ( ftHg ) )

	int						AlphaChDrawMode ;						// `ɐlނǂ( TRUE:l  FALSE:ʏ탂[h )

	int						BlendMode ;								// uh[h
	int						BlendParam ;							// uhp[^

	int						BlendGraph ;							// uhOtBbNnh
//	int						BlendGraphType ;						// uhOtBbN^Cv
//	int						BlendGraphFadeRatio ;					// uhOtBbÑtF[hp[^
	int						BlendGraphBorderParam ;					// uhOtBbNnh̃uhEl(0`255)
	int						BlendGraphBorderRange ;					// uhOtBbNnh̋E̕(0`255)
	int						BlendGraphX, BlendGraphY ;				// uhOtBbN̋N_W

	int						AlphaTestMode ;							// At@eXg[h
	int						AlphaTestParam ;						// At@eXgp[^

	int						NotUseSpecular ;						// XyLgpȂǂ
	int						ShadowMap[ MAX_USE_SHADOWMAP_NUM ] ;	// gpVhE}bvOtBbNnh
	int						UseShadowMapNum ;						// LȃVhE}bv̐ݒ萔

	int						ShadowMapDrawSetupRequest ;				// VhE}bvɑ΂`揀NGXg
	int						ShadowMapDraw ;							// VhE}bvɑ΂`悩ǂ̃tO
	int						ShadowMapDrawHandle ;					// VhE}bvɑ΂`̍ۂ́AVhE}bvnh

	union
	{
		RGBCOLOR			DrawBright ;							// `Px
		DWORD				bDrawBright ;
	} ;

	int						IgnoreGraphColorFlag ;					// `悷摜̐F𖳎邩ǂ̃tO

	int						TargetScreen[ DX_RENDERTARGET_COUNT ] ;	// `OtBbNʒl
	int						TargetScreenSurface[ DX_RENDERTARGET_COUNT ] ; // `OtBbNT[tFXCfbNX
//	int						TargetScreenVramFlag ;					// `OtBbNuq`lɑ݂邩ۂ
	int						TargetZBuffer ;							// `yobt@ʒl
//	RECT					WindowDrawRect ;						// fXNgbv̂T[tFXɕ`揈s
																	// ꍇEChẼNCAg̈̋`f[^Ă

	RECT					OriginalDrawRect ;						// EChËʒuɂĉςO̎gp҂Ӑ}鐳``
	RECT					DrawArea ;								// `\`
	RECTF					DrawAreaF ;								// `\`_^
	int						DrawSizeX, DrawSizeY ;					// `Ώۂ̃TCY
	float					Draw3DScale ;							// Rc`揈̃XP[

	int						MatchHardwareMatrix ;					// RcfoCXɐݒ肳ĂsƖ{\̒̍s񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )

	int						MatchHardwareWorldMatrix ;				// RcfoCXɐݒ肳Ă郏[hϊsƖ{\̒̃[hϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX_D				WorldMatrix ;							// [hϊs
	MATRIX					WorldMatrixF ;							// [hϊs

	int						MatchHardwareViewMatrix ;				// RcfoCXɐݒ肳Ăr[ϊsƖ{\̒̃r[ϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX_D				ViewMatrix ;							// r[ϊs
	MATRIX					ViewMatrixF ;							// r[ϊs

	int						MatchHardwareProjectionMatrix ;			// RcfoCXɐݒ肳ĂˉeϊsƖ{\̒̎ˉeϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX_D				ProjectionMatrix ;						// ˉeϊs
	MATRIX					ProjectionMatrixF ;						// ˉeϊs

	int						ProjectionMatrixMode ;					// ˉes񃂁[h( 0:ߖ@  1:ˉe  2:sw )
	double					ProjNear, ProjFar ;						// yNbsO Nearʂ Far
	double					ProjDotAspect ;							// hbgAXyNg( c /  )
	double					ProjFov ;								// ߖ@̎p
	double					ProjSize ;								// ˉẽTCY
	MATRIX_D				ProjMatrix ;							// ˉes

	MATRIX_D				Direct3DViewportMatrix ;				// cRc Iȃr[|[gs
	MATRIX					Direct3DViewportMatrixF ;				// cRc Iȃr[|[gs
	MATRIX_D				Direct3DViewportMatrixAnti ;			// cRc Iȃr[|[gs𖳌ɂs
	MATRIX					Direct3DViewportMatrixAntiF ;			// cRc Iȃr[|[gs𖳌ɂs
	MATRIX_D				ViewportMatrix ;						// r[|[gs
	MATRIX					ViewportMatrixF ;						// r[|[gs
//	MATRIX					ViewportMatrix2D ;						// Qc`pr[|[gs
//	MATRIX					ProjectionMatrix2D ;					// Qc`pˉes
//	int						UseProjectionMatrix2D ;					// Qc`pˉesgpݒɂȂĂ邩ǂ( TRUE:gp  FALSE:gpȂ )

	int						ValidBlendMatrix ;						// BlendMatrix, ViewProjectionMatrix, BillboardMatrix Lǂ( TRUE:L  FALSE: )
	MATRIX_D				BlendMatrix ;							// [hϊAr[ϊAˉeϊAr[|[gϊs|킹
	MATRIX					BlendMatrixF ;							// float^ BlendMatrix
	int						ValidInverseBlendMatrix ;				// BlendMatrix ̋ts񂪗Lǂ( TRUE:L  FALSE: )
	MATRIX_D				InverseBlendMatrix ;					// BlendMatrix ̋ts
	MATRIX					InverseBlendMatrixF ;					// float^ InverseBlendMatrix
	MATRIX_D				WorldViewMatrix ;						// [hsƃr[s|킹
	MATRIX_D				ViewProjectionViewportMatrix ;			// r[sƎˉesƃr[|[gs|킹
	MATRIX_D				BillboardMatrix ;						// r{[hp̍s
	MATRIX					BillboardMatrixF ;						// r{[hp̍s
	VECTOR_D				ViewClipPos[ 2 ][ 2 ][ 2 ] ;			// 䒸_( [ 0:z+ 1:z- ][ 0:top 1:bottom ][ 0:left 1:right ] )
	DOUBLE4					ClippingPlane[ 6 ] ;					// NbsO( 0:-x 1:+x 2:-y 3:+y 4:-z 5:+z )
	int						ValidConvScreenPosToWorldPosMatrix ;	// ʍWXN[WɕϊۂɎgps񂪗Lǂ( TRUE:L  FALSE: )
	MATRIX_D				ConvScreenPosToWorldPosMatrix ;			// ʍWXN[WɕϊۂɎgps

	int						TextureAddressTransformUse ;			// eNX`Wϊsǂ( TRUE:s  FALSE:sȂ )
//	float					TextureTransX ;							// eNX`sړ
//	float					TextureTransY ;
//	float					TextureScaleX ;							// eNX`g嗦
//	float					TextureScaleY ;
//	float					TextureRotateCenterX ;					// eNX`]̒SW
//	float					TextureRotateCenterY ;
//	float					TextureRotate ;							// eNX`]l
//	int						TextureMatrixValid ;					// TextureMatrix Lǂ( TRUE:L  FALSE: )
//	MATRIX					TextureMatrix ;							// TextureTransX  TextureScaleY ȂǂgpȂŐݒ肷s
	int						MatchHardwareTextureAddressTransformMatrix ;	// RcfoCXɐݒ肳ĂeNX`WϊsƖ{\̒̃eNX`Wϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX					TextureAddressTransformMatrix ;			// eNX`Wϊs

	GRAPHICSSYS_USERRENDERINFO	UserShaderRenderInfo ;				// SetUseTextureToShader Őݒ肳ꂽeXe[W̃eNX`A[U[ݒ̃VF[_[萔Ȃ
} ;

// 摜쐬Ɋ֌W̍\
struct GRAPHICSSYS_CREATEIMAGEDATA
{
	int						ColorBitDepth ;							// 쐬摜̐F[x
	int						ChannelBitDepth ;						// 쐬摜̂P`lӂ̃rbg[x( 炪ݒ肳Ăꍇ CreateImageColorBitDepth D悳 )
//	int						TextureImageCreateFlag ;				// eNX`摜쐬tO
	int						AlphaChannelFlag ;						// `lt摜쐬wtO( DrawValidGraphCreateFlag ̕Dx )
	int						AlphaTestFlag ;							// eXgt摜쐬wtO( AlphaGraphCreateFlag ̕Dx )( eNX`T[tFX̂ )
	int						CubeMapFlag ;							// L[u}bveNX`쐬wtO( 1:L[u}bveNX`쐬  0:ʏeNX`쐬 )
//	int						SystemMemImageCreateFlag ;				// VXegp摜쐬wtO( WT[tFX̂ )
	int						BlendImageFlag ;						// uhp摜쐬wtO
	int						NotUseManagedTextureFlag ;				// }l[WheNX`gpȂAtO( 1:gpȂ  0:gp )

	int						DrawValidFlag ;							// `\摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidAlphaFlag ;					// `\ȃ`lt摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidFloatTypeFlag ;				// `\Float^摜쐬wtO( eNX`T[tFX̂ )
	int						NotDrawValidCreateZBufferFlag ;			// `\摜쐬ۂɐp̂yobt@͍쐬Ȃǂ
	int						DrawValidChannelNum ;					// `\摜̃`l( eNX`T[tFX̂ )
	int						DrawValidZBufferBitDepth ;				// `\摜̂yobt@̃rbg[x( eNX`T[tFX̂ )
	int						DrawValidMSSamples ;					// `\ȉ摜̃}`TvO
	int						DrawValidMSQuality ;					// `\ȉ摜̃}`TvONIeB

	int						NotGraphBaseDataBackupFlag ;			// OtBbNnh쐬ۂɎgp摜f[^obNAbvȂǂ̃tO( TRUE:obNAbvȂ  FALSE:obNAbv )
	int						LeftUpColorIsTransColorFlag ;			// 摜̃sNZF𓧉ߐFɂ邩ǂ̃tO
	int						UseTransColorFlag ;						// ߐFƂłȂ̋E炩ɂ邩AtO
	DWORD					TransColor ;							// ߐF
	int						NotUseTransColor;						// ߐFgpȂǂtO(TRUE:gpȂ  FALSE:gp)
	int						NotUseDivFlag ;							// 摜sȂǂ( TRUE:sȂ  FALSE:s )
	int						MipMapCount ;							// ō쐬~bv}bv̐( -1:ő僌x܂ō쐬 )
	int						UserMaxTextureSize ;					// [U[w̃eNX`őTCY
	int						NotUseAlphaImageLoadFlag ;				// _a tAt@`lp̉摜t@CǉœǂݍޏsȂǂ( TRUE:sȂ  FALSE:s )
} ;

// fBXvC̏
struct GRAPHICSSYS_DISPLAYINFO
{
	RECT					DesktopRect ;							// fXNgbvł̃j^̈
	int						DesktopSizeX ;							// fXNgbvł̕
	int						DesktopSizeY ;							// fXNgbvł̍
	int						DesktopColorBitDepth ;					// fXNgbvł̃J[rbg[x
	int						DesktopRefreshRate ;					// fXNgbvł̃tbV[g
	wchar_t					Name[ 128 ] ;							// O

	int						ModeNum ;								// ύX\ȃfBXvC[h̐
	DISPLAYMODEDATA			*ModeData ;								// fBXvC[hXg
} ;

// ʊ֌W̏̍\
struct GRAPHICSSYS_SCREENDATA
{
	int						MainScreenSizeX ;						// Cʂ̃TCY
	int						MainScreenSizeY ;
	int						MainScreenSizeX_Result ;				// GetDrawScreenSize ̕ԂlɂȂTCY
	int						MainScreenSizeY_Result ;
	int						MainScreenColorBitDepth ;				// Cʂ̃J[rbg[x
	int						MainScreenRefreshRate ;					// Cʂ̃tbV[g

	int						Emulation320x240Flag ;					// 640x480 ̉ʂ 320x240 ̉ʂo͂邩ǂ̃tO

	int						FullScreenResolutionMode ;				// tXN[𑜓x[h( DX_FSRESOLUTIONMODE_NATIVE  )
	int						FullScreenResolutionModeAct ;			// ۂɎgpĂtXN[𑜓x[h( Ⴆ FullScreenMode  DX_FSRESOLUTIONMODE_NATIVE łw̉𑜓xɃj^ΉĂȂꍇ͂̕ϐ DX_FSRESOLUTIONMODE_MAXIMUM ɂȂ )
	int						FullScreenScalingMode ;					// tXN[XP[O[h( DX_FSSCALINGMODE_NEAREST  )
	DISPLAYMODEDATA			FullScreenUseDispModeData ;				// tXN[[hŎgpĂfBXvC[h̏
	RECT					FullScreenScalingDestRect ;				// DX_FSRESOLUTIONMODE_NATIVE ȊOŃtXN[[hɎgp]`
	RECT					FullScreenDesktopRect ;					// tXN[[hł̎gpĂfXNgbv̋`

//	int						PreSetWaitVSyncFlag ;					// DxLib_Init Ă΂O SetWaitVSyncFlag( TRUE ) ; sꂽǂ̃tO( TRUE:sꂽ  FALSE:sĂȂ )
	int						NotWaitVSyncFlag ;						// urxmb҂Ȃǂ̃tOiTRUEFȂ FALSEFj

	int						ValidGraphDisplayArea ;					// GraphDisplayArea ɗLȒlĂ邩ǂ
	RECT					GraphDisplayArea ;						// \ʂɓ]闠ʂ̗̈

	int						EnableBackgroundColor ;					// obNOEhhׂpJ[Lǂ̃tO
	int						BackgroundRed ;							// obNOEhhׂpJ[
	int						BackgroundGreen ;
	int						BackgroundBlue ;

	int						ScreenFlipFlag ;						// ScreenFlip֐ĂтtO
	int						Graphics_Screen_ChangeModeFlag ;		// Graphics_Screen_ChangeMode sǂ̃tO

//	int						DisplayModeNum ;						// ύX\ȃfBXvC[h̐
//	DISPLAYMODEDATA			*DisplayMode ;							// fBXvC[hXg
	int						ValidUseDisplayIndex ;					// UseDisplayIndex Lǂ( TRUE:L  FALSE: )
	int						UseDisplayIndex ;						// gpfBXvCԍ

	int						DisplayNum ;							// fBXvC̐
	GRAPHICSSYS_DISPLAYINFO	*DisplayInfo ;							// fBXvC̏

	int						DrawScreenBufferLockFlag ;				// obNobt@bNĂ邩ǂtO
} ;

// ݒ֌W̍\
struct GRAPHICSSYS_SETTINGDATA
{
	void					( *GraphRestoreShred )( void ) ;		// OtBbN֐̃|C^ 

	int						ValidHardware ;							// n[hEGA`悪\ǂ( TRUE:\  FALSE:s\ )
	int						NotUseHardware ;						// n[hEGA`̋@\gpȂǂ( TRUE:gpȂ  FALSE:gp )
	int						ChangeScreenModeNotGraphicsSystemFlag ;	// ʃ[h̕ύXɉ摜nh폜Ȃǂ( TRUE:Ȃ  FALSE: )
} ;

// sp\[X֌W̍\
struct GRAPHICSSYS_RESOURCE
{
	int						TempVertexBufferSize ;					// ꎞIɒ_f[^i[邽߂̃obt@̃TCY
	void					*TempVertexBuffer ;						// ꎞIɒ_f[^i[邽߂̃obt@

	void					*CommonBuffer[ COMMON_BUFFER_NUM ] ;	// ėpobt@
	DWORD					CommonBufferSize[ COMMON_BUFFER_NUM ] ;	// ėpobt@̃mۃTCY

	int						WhiteTexHandle ;						// 8x8̔eNX`̃nh
} ;

// n[hEFAANZ[^֌W̍\
struct GRAPHICSSYS_HARDWAREINFO
{
	int						ValidSubBlend ;							// Zuh\ǂ( TRUE:\  FALSE:s\ )
	int						TextureSquareOnly ;						// `eNX`̂ݍ쐬\ǂ( TRUE:`eNX`̂  FALSE:`eNX`ȊO\ )
	int						RenderTargetNum ;						// Ƀ_Oł郌_[^[Qbg̐
	int						TextureSizeNonPow2Conditional ;			// tŃeNX`̃TCYQ̂łȂĂvǂ
	int						TextureSizePow2 ;						// eNX`̃TCYQ̂łKv邩ǂ
	int						MaxTextureSize ;						// őeNX`TCY
	int						MaxTextureWidth ;						// őeNX`
	int						MaxTextureHeight ;						// őeNX`
	int						MaxPrimitiveCount ;						// xɕ`łv~eBu̍ő吔
	int						MaxVertexIndex ;						// x̎gp邱Ƃ̏oő咸_
	int						UseShader ;								// vO}uVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						UseVertexColorBGRAFormat ;				// BGRAJ[^Cv̒_J[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						DrawFloatCoordType ;					// DrawGraphF ̕_lōWw肷֐ɂW^Cv( DX_DRAWFLOATCOORDTYPE_DIRECT3D9 Ȃ )
} ;

// \tgEGA_OŎgp̍\
struct GRAPHICSSYS_SOFTRENDERDATA
{
	MEMIMG					MainBufferMemImg ;					// Cʗp MEMIMG
	MEMIMG					SubBufferMemImg ;					// ⏕ʗp MEMIMG
	MEMIMG					FontScreenMemImgNormal ;			// `Ȃǂ̎ɎgtHgp MEMIMG ( At@Ȃ )
	MEMIMG					FontScreenMemImgAlpha ;				// `Ȃǂ̎ɎgtHgp MEMIMG ( At@ )
	MEMIMG					*TargetMemImg ;						// `Ώۂ MEMIMG
	MEMIMG					*BlendMemImg ;						// uh`p MEMIMG
} ;

// OtBNXVXepf[^\
struct GRAPHICSSYSTEMDATA
{
	int								InitializeFlag ;						// tO

//	int								NotDrawFlag ;							// `s\tO

//	int								Screen3DWidth ;							// Rc`sۂ̑z肷XN[̃TCY
//	int								Screen3DHeight ;
//	int								Screen3DCenterX ;						// Rc`sۂ̑z肷XN[̒SW
//	int								Screen3DCenterY ;
//	LONGLONG						FrameCounter ;							// t[JE^[

	GRAPHICSSYS_SETTINGDATA			Setting ;								// ݒ֌W̏

	GRAPHICSSYS_HARDWAREINFO		HardInfo ;								// n[hEFAANZ[^֌W̏

	GRAPHICSSYS_SOFTRENDERDATA		SoftRender ;							// \tgEGA_OŎgp

	GRAPHICSSYS_SCREENDATA			Screen ;								// ʊ֌W̏

	GRAPHICSSYS_CREATEIMAGEDATA		CreateImage ;							// 摜쐬֌W̏

	GRAPHICSSYS_RESOURCE			Resource ;								// sp\[X֌W̍\

	GRAPHICSSYS_DRAWSETTINGDATA		DrawSetting ;							// `ݒ֌W̏

	GRAPHICSSYS_LIGHTATA			Light ;									// Cg֌W̏

	GRAPHICSSYS_CAMERA				Camera ;								// J֌W̏

	int								ChangeSettingFlag ;						// ݒ肪ύXꂽǂ
} ;

// ϐ錾---------------------------------------------------------------

// `̊{Iȏ
extern GRAPHICSSYSTEMDATA GraphicsSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

// OtBbN֘Ȁƌn
extern	int		Graphics_Initialize( void ) ;					// OtBbNXVXȅ
extern	int		Graphics_Terminate( void ) ;					// OtBbNVXěn
extern	int		Graphics_RestoreOrChangeSetupGraphSystem( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 ) ;		// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs








// ʊ֌W֐
extern	int		Graphics_Screen_SetupFullScreenModeInfo( void ) ;											// tXN[[h̃[h̃`FbNgp𑜓x̌s
extern	int		Graphics_Screen_SetupFullScreenScalingDestRect( void ) ;									// GSYS.Screen.FullScreenScalingDestRect ̒lZbgAbv
extern	int		Graphics_Screen_ScreenPosConvSubBackbufferPos( int ScreenPosX, int ScreenPosY, int *BackBufferPosX, int *BackBufferPosY ) ;	// XN[WTuobNobt@[Wɕϊ
extern	int		Graphics_Screen_SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;	// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Screen_SetupUseZBuffer( void ) ;													// ݒɊÂĎgpyobt@Zbg
extern	void	Graphics_Screen_SetMainScreenSize( int SizeX, int SizeY ) ;									// Cʂ̃TCYlύX
extern	int		Graphics_Screen_ChangeMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int ChangeWindowFlag, int RefreshRate ) ;				// ʃ[h̕ύXQ
extern	int		Graphics_Screen_LockDrawScreen( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen/* = -1*/, int TargetScreenSurface/* = -1*/, int ReadOnly/* = TRUE*/, int TargetScreenTextureNo/* = 0*/ ) ;	// `obt@bN
extern	int		Graphics_Screen_UnlockDrawScreen( void ) ;													// `obt@AbN
extern	int		Graphics_Screen_FlipBase( void ) ;															// ScreenFlip ̃x[X֐








// 摜֌W֐
extern	int		Graphics_Image_SetupFormatDesc( IMAGEFORMATDESC *Format, SETUP_GRAPHHANDLE_GPARAM *GParam, int Width, int Height, int AlphaValidFlag, int UsePaletteFlag, int BaseFormat, int MipMapCount ) ; // OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Image_DeleteDeviceLostDelete( void ) ;						// foCXXgɍ폜tOĂOtBbN폜
extern	int		Graphics_Image_CheckMultiSampleDrawValid( int GrHandle ) ;			// lr``gp`\摜ǂ𒲂ׂ( TRUE:MSAA摜  FALSE:MSAA摜ł͂Ȃ )
extern	int		Graphics_Image_AddHandle( int ASyncThread ) ;																			// VOtBbNnhmۂ
extern	int		Graphics_Image_SetupHandle_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int GrHandle, int Width, int Height, int TextureFlag, int AlphaValidFlag, int UsePaletteFlag, int BaseFormat/* = DX_BASEIMAGE_FORMAT_NORMAL*/, int MipMapCount, int ASyncThread ) ;							// SetupGraphHandle ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_ListUpTexSize( int Size, short *SizeList, int NotDivFlag, int Pow2Flag, int MaxTextureSize ) ;			// w̃eNX`[TCY肭
extern	int		Graphics_Image_InitializeHandle( HANDLEINFO *HandleInfo ) ;																// OtBbNnh̏
extern	int		Graphics_Image_TerminateHandle( HANDLEINFO *HandleInfo ) ;																// OtBbNnȟn
extern	int		Graphics_Image_InitializeDerivationHandle( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGrHandle, int ASyncThread = FALSE ) ;			// w蕔𔲂oOtBbNnh
extern	int		Graphics_Image_InitializeDrawInfo( int GrHandle, int ASyncThread = FALSE ) ;			// OtBbNnh̕`
extern	int		Graphics_Image_IsValidHandle( int GrHandle ) ;															// OtBbNnhLǂ𒲂ׂ( TRUE:L  FALSE: )
extern	int		Graphics_Image_CreateDXGraph_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int GrHandle, const BASEIMAGE *RgbBaseImage, const BASEIMAGE *AlphaBaseImage, int TextureFlag, int ASyncThread = FALSE ) ;																															// CreateDXGraph ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_DerivationGraph_UseGParam( int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle, int ASyncThread = FALSE ) ;																																												// DerivationGraph ̃O[oϐɃANZXȂo[W
#ifndef DX_NON_MOVIE
extern	int		Graphics_Image_OpenMovie_UseGParam( LOADGRAPH_GPARAM *GParam, int GrHandle, const wchar_t *GraphName, int TextureFlag, int SurfaceMode = DX_MOVIESURFACE_NORMAL, int ASyncThread = FALSE ) ;
#endif
extern	int		Graphics_Image_DerivationGraphBase( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle, int ASyncThread = FALSE ) ;																																								// OtBbNnh쐬Ȃ DerivationGraph
extern	int		Graphics_Image_SetBaseInfo_UseGParam( SETGRAPHBASEINFO_GPARAM *GParam, int GrHandle, const wchar_t *FileName, const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, const void *MemImage, int MemImageSize,
										   const void *AlphaMemImage, int AlphaMemImageSize, const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;																														// SetGraphBaseInfo ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_SetGraphBaseInfo( int GrHandle, const wchar_t *FileName, const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, const void *MemImage, int MemImageSize, const void *AlphaMemImage, int AlphaMemImageSize, const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;		// 摜̌f[^̏ۑ
extern	int		Graphics_Image_SetName( int Handle, const wchar_t *GraphName, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;	// ̃t@C摜ǂݍ񂾏ꍇ̃t@CpXZbg
extern	int		Graphics_Image_FillGraph_UseGParam( int GrHandle, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;																																																// FillGraph ̃O[oϐɃANZXȂo[W
#ifndef DX_NON_MOVIE
extern	void	Graphics_Image_UpdateGraphMovie( MOVIEGRAPH *Movie, DWORD_PTR GrHandle ) ;				// [r[摜XV
#endif

// BltBmpOrGraphImageToGraph ̓֐
extern	int		Graphics_Image_BltBmpOrGraphImageToGraphBase(
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		CopyPointX,
	      int		CopyPointY,
	      int		GrHandle,
	      int		UseTransColorConvAlpha = TRUE,
	      int		ASyncThread = FALSE
) ;

// BltBmpOrGraphImageToGraph2 ̓֐
extern	int		Graphics_Image_BltBmpOrGraphImageToGraph2Base(
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	      int		UseTransColorConvAlpha = TRUE,
	      int		ASyncThread = FALSE
) ;

// BltBmpOrGraphImageToDivGraph ̓֐
extern	int		Graphics_Image_BltBmpOrGraphImageToDivGraphBase(
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		AllNum,
	      int		XNum,
	      int		YNum,
	      int		Width,
	      int		Height,
	const int		*GrHandle,
	      int		ReverseFlag,
	      int		UseTransColorConvAlpha = TRUE,
	      int		ASyncThread = FALSE
) ;

// OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Image_BltBmpOrBaseImageToGraph3(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag = FALSE,
	      int		UseTransColorConvAlpha = TRUE,
	      int		TargetOrig = FALSE,
	      int		ASyncThread = FALSE
) ;

// w̃IWi摜ɓ]`쐬
// ߂l  -1:͈͊O   0:I
extern	int		Graphics_Image_BltBmpOrBaseImageToGraph3_Make_OrigTex_MoveRect(
	const IMAGEDATA_ORIG_HARD_TEX	*OrigTex,
	const RECT						*SrcRect,
		  int						SrcWidth,
		  int						SrcHeight,
	      int						DestX,
	      int						DestY,
	      RECT						*DestRect,
	      RECT						*MoveRect
) ;

// w̕`p摜ɓ]`쐬
// ߂l  -1:͈͊O   0:I
extern	int		Graphics_Image_BltBmpOrBaseImageToGraph3_Make_DrawTex_MoveRect(
	const IMAGEDATA_HARD_DRAW		*DrawTex,
	const RECT						*SrcRect,
		  int						SrcWidth,
		  int						SrcHeight,
	      int						DestX,
	      int						DestY,
	      RECT						*DestRect,
	      RECT						*MoveRect
) ;

// `\摜obNobt@ẅ̃OtBbN擾
extern	int			Graphics_Image_GetDrawScreenGraphBase( int TargetScreen, int TargetScreenSurface, int x1, int y1, int x2, int y2, int destX, int destY, int GrHandle ) ;
extern	IMAGEDATA *	Graphics_Image_GetData( int GrHandle, int ASyncThread = FALSE ) ;				// OtBbÑf[^CfbNXlo
extern	int			Graphics_Image_GetWhiteTexHandle( void ) ;										// ^̃eNX`̃nh擾

extern	int		Graphics_Image_MakeGraph_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int SizeX, int SizeY, int NotUse3DFlag, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																											// ̃OtBbNnh쐬֐
extern	int		Graphics_Image_CreateGraph_UseGParam(                  LOADGRAPH_PARAM *Param, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																																			// 摜f[^OtBbNnh쐬֐
extern	int		Graphics_Image_CreateDivGraph_UseGParam(               LOADGRAPH_PARAM *Param, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																																			// 摜f[^𕪊ăOtBbNnh쐬֐
extern	int		Graphics_Image_LoadBmpToGraph_UseGParam(               LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const wchar_t *GraphName, int TextureFlag, int ReverseFlag, int SurfaceMode = DX_MOVIESURFACE_NORMAL, int ASyncLoadFlag = FALSE ) ;																								// LoadBmpToGraph ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_LoadDivBmpToGraph_UseGParam(            LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const wchar_t *FileName, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																	// LoadDivBmpToGraph ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateGraphFromMem_UseGParam(           LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const void *MemImage, int MemImageSize, const void *AlphaImage = NULL, int AlphaImageSize = 0, int TextureFlag = TRUE, int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;																// CreateGraphFromMem ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateDivGraphFromMem_UseGParam(        LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;		// CreateDivGraphFromMem ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateGraphFromBmp_UseGParam(           LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const BITMAPINFO *BmpInfo, const void *GraphData, const BITMAPINFO *AlphaInfo = NULL, const void *AlphaData = NULL, int TextureFlag = TRUE, int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;											// CreateGraphFromBmp ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateDivGraphFromBmp_UseGParam(        LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf,int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData, int ASyncLoadFlag = FALSE ) ;	// CreateDivGraphFromBmp ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateGraphFromGraphImage_UseGParam(    LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag = TRUE , int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																	// CreateGraphFromGraphImage ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateDivGraphFromGraphImage_UseGParam( LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag = TRUE , int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;									// CreateDivGraphFromGraphImage ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateGraphFromGraphImageBase_UseGParam(    CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam, int ReCreateFlag, int GrHandle,   BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag, int ASyncThread = FALSE ) ;																							// Graphics_Image_CreateGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateDivGraphFromGraphImageBase_UseGParam( CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam, int ReCreateFlag, int BaseHandle, BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag, int ASyncThread = FALSE ) ;		// Graphics_Image_CreateDivGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W
extern	int		Graphics_Image_CreateGraphFromGraphImageBase(      BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag, int ASyncThread ) ;																								// CreateGraphFromGraphImage ̓֐
extern	int		Graphics_Image_CreateDivGraphFromGraphImageBase(   BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag ) ;						// CreateDivGraphFromGraphImage ̓֐
extern	int		Graphics_Image_ReCreateGraphFromGraphImageBase(    BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int GrHandle, int TextureFlag ) ;																									// ReCreateGraphFromGraphImage ̓֐
extern	int		Graphics_Image_ReCreateDivGraphFromGraphImageBase( BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag , int ReverseFlag ) ;						// ReCreateDivGraphFromGraphImage ̓֐
extern	void	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam ) ;			// CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM ̃f[^Zbg
extern	void	Graphics_Image_InitSetupGraphHandleGParam( SETUP_GRAPHHANDLE_GPARAM *GParam ) ;												// SETUP_GRAPHHANDLE_GPARAM ̃f[^Zbg
extern	void	Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth = 32, int AlphaChannel = TRUE, int AlphaTest = FALSE ) ;
extern	void	Graphics_Image_InitSetupGraphHandleGParam_Normal_DrawValid_NoneZBuffer( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth = 32, int AlphaChannel = TRUE ) ;
extern	void	Graphics_Image_InitSetGraphBaseInfoGParam( SETGRAPHBASEINFO_GPARAM *GParam ) ;													// SETGRAPHBASEINFO_GPARAM ̃f[^Zbg
extern	void	Graphics_Image_InitLoadGraphGParam( LOADGRAPH_GPARAM *GParam ) ;																// LOADGRAPH_GPARAM ̃f[^Zbg
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_MOVIE
extern	void	Graphics_Image_InitOpenMovieGParam( OPENMOVIE_GPARAM *GParam ) ;																// OPENMOVIE_GPARAM ̃f[^Zbg
#endif
#endif







// `ݒ֌W֐
extern	int				Graphics_DrawSetting_Initialize( void ) ;															// OtBbN`ݒ֌W̏
extern	void FASTCALL	Graphics_DrawSetting_SetDrawBrightToOneParam( DWORD Bright ) ;										// SetDrawBright ̈
extern	void FASTCALL	Graphics_DrawSetting_BlendModeSub_Pre( RECT *DrawRect ) ;
extern	void FASTCALL	Graphics_DrawSetting_BlendModeSub_Post( RECT *DrawRect ) ;
extern	int				Graphics_DrawSetting_SetBlendGraphParamBase( int BlendGraph, int BlendType, va_list ParamList ) ;	// SetBlendGraphParam ̉ϒp[^t
extern	int				Graphics_DrawSetting_RefreshAlphaChDrawMode( void ) ;												// `ɐlނǂ̃tOXV
extern	void			Graphics_DrawSetting_ApplyLibMatrixToHardware( void ) ;												// {f[^ɐݒ肳Ăsn[hEGAɔf
extern	void			Graphics_DrawSetting_ApplyLibFogToHardware( void ) ;												// {f[^ɐݒ肳ĂtHOn[hEGAɔf
extern	int				Graphics_DrawSetting_SetTextureAddressTransformMatrix_Direct( int Use, MATRIX *Matrix, int Stage = -1 ) ;		// eNX`WϊsZbg
extern	int				Graphics_DrawSetting_SetTransformToWorld_Direct( MATRIX *Matrix ) ;									// [J[hsύX
extern	int				Graphics_DrawSetting_SetTransformToProjection_Direct( const MATRIX_D *Matrix ) ;					// eϊpsZbg
extern	void			Graphics_DrawSetting_RefreshProjectionMatrix( void ) ;												// ˉesp[^ɊÂĎˉes\z
extern	void			Graphics_DrawSetting_RefreshBlendTransformMatrix( void ) ;											// _ϊs|킹sXV
//extern	void		Graphics_DrawSetting_SetUse2DProjectionMatrix( int Use2DProjectionMatrix ) ;						// gpˉesRcpɂ邩Qcpɂ邩ݒ肷
extern	int				Graphics_DrawSetting_GetScreenDrawSettingInfo(       SCREENDRAWSETTINGINFO *ScreenDrawSettingInfo ) ;	// cwCu SetDrawScreen gpĕ`ύXۂ́ÃJݒ`̈𕜌ׂ̏擾鏈s
extern	int				Graphics_DrawSetting_SetScreenDrawSettingInfo( const SCREENDRAWSETTINGINFO *ScreenDrawSettingInfo ) ;	// cwCu SetDrawScreen gpĕ`ύXۂ́ÃJݒ`̈𕜌鏈s








// `֌W֐
extern	int		Graphics_Draw_GetCircle_ThicknessDrawPosition( int x, int y, int r, int Thickness, short ( *CirclePos )[ 5 ] ) ;		// ̕t~̕`p_擾֐
extern	int		Graphics_Draw_GetOval_ThicknessDrawPosition( int x, int y, int rx, int ry, int Thickness, short ( *CirclePos )[ 5 ] ) ;	// ̕tȉ~̕`p_擾֐
extern	int		Graphics_Draw_DrawSimpleTwoTriangleGraphF( const GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_PARAM *Param ) ;				// W␳sȂQ|S`s( PeNX`摜̂ݗL )








// J֌W֐
extern	int		Graphics_Camera_CheckCameraViewClip_Box_PosDim(  VECTOR   *CheckBoxPos ) ;					// WWŌ`{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )( CheckPos VECTOR 8̔z̐擪AhXAz̊evfԍ̓e 0:+x +y +z   1:-x +y +z   2:-x -y +z   3:+x -y +z   4:+x -y -z   5:+x +y -z   6:-x +y -z   7:-x -y -z )
extern	int		Graphics_Camera_CheckCameraViewClip_Box_PosDimD( VECTOR_D *CheckBoxPos ) ;					// WWŌ`{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )( CheckPos VECTOR 8̔z̐擪AhXAz̊evfԍ̓e 0:+x +y +z   1:-x +y +z   2:-x -y +z   3:+x -y +z   4:+x -y -z   5:+x +y -z   6:-x +y -z   7:-x -y -z )
extern	void	Graphics_Camera_CalcCameraRollViewMatrix( void ) ;											// r[s񂩂琅AAPpxZo








// Cg֌W֐
extern	int		Graphics_Light_AddHandle( void ) ;														// Cgnh̒ǉ
extern	int		Graphics_Light_RefreshState( void ) ;													// Cg̕ύX𔽉f








// VF[_[֌W֐
extern	int		Graphics_Shader_CreateHandle( int ASyncThread ) ;																	// VF[_[nh쐬
extern	int		Graphics_Shader_CreateHandle_UseGParam( int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;		// VF[_[nh쐬
extern	int		Graphics_Shader_LoadShader_UseGParam( int IsVertexShader, const wchar_t *FileName, int ASyncLoadFlag = FALSE ) ;	// VF[_[oCit@Cǂݍ
extern	int		Graphics_Shader_InitializeHandle( HANDLEINFO *HandleInfo ) ;														// VF[_[nh̏
extern	int		Graphics_Shader_TerminateHandle( HANDLEINFO *HandleInfo ) ;															// VF[_[nȟn
extern	SHADERHANDLEDATA *Graphics_Shader_GetData( int ShaderHandle, int ASyncThread = FALSE ) ;									// VF[_[f[^nhlo







// 萔obt@֌W֐
extern	int		Graphics_ShaderConstantBuffer_CreateHandle( int ASyncThread ) ;																// VF[_[p萔obt@nh쐬
extern	int		Graphics_ShaderConstantBuffer_Create( int BufferSize, int ASyncLoadFlag = FALSE,  int ASyncThread = FALSE ) ;				// VF[_[p萔obt@nh쐬
extern	int		Graphics_ShaderConstantBuffer_InitializeHandle( HANDLEINFO *HandleInfo ) ;													// VF[_[p萔obt@nh̏
extern	int		Graphics_ShaderConstantBuffer_TerminateHandle( HANDLEINFO *HandleInfo ) ;													// VF[_[p萔obt@nȟn








// _obt@ECfbNXobt@֌W֐
extern	int		Graphics_VertexBuffer_Create( int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */, int ASyncThread ) ;			// _obt@쐬
extern	int		Graphics_VertexBuffer_SetupHandle( int VertexBufHandle, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ ) ;	// _obt@nh̃ZbgAbvs
extern	int		Graphics_VertexBuffer_InitializeHandle( HANDLEINFO *HandleInfo ) ;															// _obt@nh̏
extern	int		Graphics_VertexBuffer_TerminateHandle( HANDLEINFO *HandleInfo ) ;															// _obt@nȟn

extern	int		Graphics_IndexBuffer_Create( int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */, int ASyncThread ) ;					// CfbNXobt@쐬
extern	int		Graphics_IndexBuffer_SetupHandle( int IndexBufHandle, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ ) ;			// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_IndexBuffer_InitializeHandle( HANDLEINFO *HandleInfo ) ;															// CfbNXobt@nh̏
extern	int		Graphics_IndexBuffer_TerminateHandle( HANDLEINFO *HandleInfo ) ;															// CfbNXobt@nȟn








// VhE}bv֌W֐
extern	int		Graphics_ShadowMap_MakeShadowMap_UseGParam( SETUP_SHADOWMAPHANDLE_GPARAM *GParam, int SizeX, int SizeY, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																														// VhE}bvnh쐬
extern	int		Graphics_ShadowMap_AddHandle( int ASyncThread ) ;																			// VVhE}bvnhmۂ
extern	int		Graphics_ShadowMap_SetupHandle_UseGParam( SETUP_SHADOWMAPHANDLE_GPARAM *GParam, int SmHandle, int SizeX, int SizeY, int TexFormat_Float, int TexFormat_BitDepth, int ASyncThread ) ;	// VhE}bvnh̃ZbgAbvs
extern	int		Graphics_ShadowMap_CreateTexture( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;										// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_ShadowMap_ReleaseTexture( SHADOWMAPDATA *ShadowMap ) ;																// VhE}bvf[^ɕKvȃeNX`
extern	SHADOWMAPDATA	*Graphics_ShadowMap_GetData( int SmHandle, int ASyncThread = FALSE ) ;												// VhE}bvf[^nhlo
extern	void	Graphics_ShadowMap_RefreshVSParam( void ) ;																					// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_ShadowMap_RefreshPSParam( void ) ;																					// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	int		Graphics_ShadowMap_RefreshMatrix( SHADOWMAPDATA *ShadowMap ) ;							// VhE}bvւ̃_OŎgps̏XV

extern	int		Graphics_ShadowMap_InitializeHandle( HANDLEINFO *HandleInfo ) ;																// VhE}bvnh̏
extern	int		Graphics_ShadowMap_TerminateHandle( HANDLEINFO *HandleInfo ) ;																// VhE}bvnȟn








// ⏕֌W֐
extern	int		Graphics_Other_AllocCommonBuffer( int Index, DWORD Size ) ;						// L̊m
extern	int		Graphics_Other_TerminateCommonBuffer( void ) ;									// L̉








// ˑ֌W
extern	int		Graphics_Initialize_Timing0_PF( void ) ;										// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_Initialize_Timing1_PF( void ) ;										// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_Hardware_Initialize_PF( void ) ;										// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_Terminate_PF( void ) ;													// `揈̊ˑ̌ns֐
extern	int		Graphics_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 ) ;		// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_Hardware_CheckValid_PF( void ) ;										// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )







// ˑ`ݒ֌W
extern	int		Graphics_Hardware_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex ) ;		// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_SetDrawBrightToOneParam_PF( DWORD Bright ) ;											// SetDrawBright ̈
extern	int		Graphics_Hardware_SetDrawBlendMode_PF( int BlendMode, int BlendParam ) ;								// `uh[hZbg
extern	int		Graphics_Hardware_SetDrawAlphaTest_PF( int TestMode, int TestParam ) ;									// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_SetDrawMode_PF( int DrawMode ) ;														// `惂[hZbg
extern	int		Graphics_Hardware_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright ) ;					// `PxZbg
extern	int		Graphics_Hardware_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param ) ;		// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_SetMaxAnisotropy_PF( int MaxAnisotropy ) ;											// őٕ̒lZbg
extern	int		Graphics_Hardware_SetTransformToWorld_PF( const MATRIX *Matrix ) ;										// [hϊpsZbg
extern	int		Graphics_Hardware_SetTransformToView_PF( const MATRIX *Matrix ) ;										// r[ϊpsZbg
extern	int		Graphics_Hardware_SetTransformToProjection_PF( const MATRIX *Matrix ) ;									// eϊpsZbg
extern	int		Graphics_Hardware_SetTransformToViewport_PF( const MATRIX *Matrix ) ;									// r[|[gsZbg
extern	int		Graphics_Hardware_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage ) ;			// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage ) ;						// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler = -1 ) ;// eNX`WϊsZbg
extern	int		Graphics_Hardware_SetFogEnable_PF( int Flag ) ;															// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ ) ;									// tHO[hݒ肷
extern	int		Graphics_Hardware_SetFogColor_PF( DWORD FogColor ) ;													// tHOJ[ύX
extern	int		Graphics_Hardware_SetFogStartEnd_PF( float start, float end ) ;											// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_SetFogDensity_PF( float density ) ;													// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_DeviceDirect_SetWorldMatrix_PF( const MATRIX *Matrix ) ;								// [hϊpsZbg
extern	int		Graphics_Hardware_DeviceDirect_SetViewMatrix_PF( const MATRIX *Matrix ) ;								// r[ϊpsZbg
extern	int		Graphics_Hardware_DeviceDirect_SetProjectionMatrix_PF( const MATRIX *Matrix ) ;							// eϊpsZbg
extern	int		Graphics_Hardware_ApplyLigFogToHardware_PF( void ) ;													// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_SetUseOldDrawModiGraphCodeFlag_PF( int Flag ) ;										// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_RefreshAlphaChDrawMode_PF( void ) ;													// `ɐlނǂ̃tOXV
//extern	void	Graphics_Hardware_SetUse2DProjectionMatrix_PF( int Use2DProjectionMatrix ) ;							// gpˉesRcpɂ邩Qcpɂ邩ݒ肷









// ˑݒ֌W
extern	int		Graphics_Hardware_SetUseHardwareVertexProcessing_PF( int Flag ) ;						// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_SetUsePixelLighting_PF( int Flag ) ;									// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_SetUseNormalDrawShader_PF( int Flag ) ;								// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_GetVideoMemorySize_PF( int *AllSize, int *FreeSize ) ;				// rfI̗eʂ𓾂
extern	int		Graphics_SetAeroDisableFlag_PF( int Flag ) ;											// Vistaȍ~ Windows Aero 𖳌ɂ邩ǂZbgATRUE:ɂ  FALSE:Lɂ( DxLib_Init ̑OɌĂԕKv܂ )












// ˑʊ֌W
extern	int		Graphics_Hardware_SetupUseZBuffer_PF( void ) ;															// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_ClearDrawScreenZBuffer_PF( const RECT *ClearRect ) ;									// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_ClearDrawScreen_PF( const RECT *ClearRect ) ;											// ʂ̏Ԃ
extern	int		Graphics_Hardware_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap ) ;					// `ʂ̃Zbg
extern	int		Graphics_Hardware_SetDrawScreen_Post_PF( int DrawScreen ) ;												// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_SetDrawArea_PF( int x1, int y1, int x2, int y2 ) ;									// `\̈̃Zbg
extern	int		Graphics_Hardware_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo ) ;	// `obt@bN
extern	int		Graphics_Hardware_UnlockDrawScreenBuffer_PF( void ) ;													// `obt@AbN
extern	int		Graphics_Hardware_ScreenCopy_PF( void ) ;																// ʂ̓e\ʂɕ`悷
extern	int		Graphics_SetupDisplayInfo_PF( void ) ;																	// fBXvC̏ZbgAbv
extern	int		Graphics_Hardware_WaitVSync_PF( int SyncNum ) ;															// M҂
extern	int		Graphics_ScreenFlipBase_PF( void ) ;																	// ʂƕ\ʂ
#ifdef __WINDOWS__
extern	int		Graphics_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect ) ;		// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_SetScreenFlipTargetWindow_PF( HWND TargetWindow ) ;											// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
#endif // __WINDOWS__
extern	int		Graphics_Hardware_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;			// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_SetFullSceneAntiAliasingMode_PF( int Samples, int Quality ) ;							// ʂ̃tV[A`GCAX[h̐ݒ
extern	int		Graphics_Hardware_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image ) ;									// `yobt@̃Zbg
extern	int		Graphics_GetRefreshRate_PF( void ) ;																	// ݂̉ʂ̃tbV[g擾













// ˑ擾֌W
extern	const COLORDATA *	Graphics_Hardware_GetMainColorData_PF( void ) ;				// GetColor  GetColor2 ŎgpJ[f[^擾
extern	const COLORDATA *	Graphics_Hardware_GetDispColorData_PF( void ) ;				// fBXv[̃J[f[^|C^𓾂
extern	DWORD				Graphics_Hardware_GetPixel_PF( int x, int y ) ;				// wW̐F擾











// ˑ摜֌W
extern	int		Graphics_Hardware_UpdateGraphMovie_TheoraYUV_PF( struct MOVIEGRAPH *Movie, IMAGEDATA *Image ) ;							// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP, int WriteOnly ) ;								// OtBbN̈̃bN
extern	int		Graphics_Hardware_GraphUnlock_PF( IMAGEDATA *Image ) ;																	// OtBbN̈̃bN
extern	int		Graphics_Hardware_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage ) ;								// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_InitGraph_PF( void ) ;																				// 摜f[^̏
extern	int		Graphics_Hardware_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;			// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY ) ;		// `\摜obNobt@ẅ̃OtBbN擾

// Graphics_Image_BltBmpOrBaseImageToGraph3 ̋@ˑp֐
extern	int		Graphics_Hardware_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
) ;

// {C[W̃tH[}bg DX_BASEIMAGE_FORMAT_NORMAL ɕϊKv邩ǂ`FbN
// ( RequiredRgbBaseImageConvFlag  RequiredAlphaBaseImageConvFlag ɓl  TRUE:ϊKv  FALSE:ϊKv͖ )
extern	int		Graphics_CheckRequiredNormalImageConv_BaseImageFormat_PF(
	IMAGEDATA_ORIG *Orig,
	int             RgbBaseImageFormat,
	int            *RequiredRgbBaseImageConvFlag,
	int             AlphaBaseImageFormat = -1,
	int            *RequiredAlphaBaseImageConvFlag = NULL
) ;

extern	int		Graphics_Hardware_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread = FALSE ) ;			// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig ) ;									// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_GetMultiSampleQuality_PF( int Samples ) ;											// w̃}`TvŎgpłőNIeBl擾













// ˑ_obt@ECfbNXobt@֌W
extern	int		Graphics_Hardware_VertexBuffer_Create_PF(    VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nȟn
extern	int		Graphics_Hardware_VertexBuffer_SetData_PF(   VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum ) ;		// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_IndexBuffer_Create_PF(     INDEXBUFFERHANDLEDATA *IndexBuffer ) ;																// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_IndexBuffer_Terminate_PF(  INDEXBUFFERHANDLEDATA *IndexBuffer ) ;																// CfbNXobt@nȟn
extern	int		Graphics_Hardware_IndexBuffer_SetData_PF(    INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum ) ;			// CfbNXobt@ɃCfbNXf[^]











// ˑCg֌W
extern	int		Graphics_Hardware_Light_SetUse_PF( int Flag ) ;															// CeBOsǂݒ肷
extern	int		Graphics_Hardware_Light_GlobalAmbient_PF( COLOR_F *Color ) ;											// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam ) ;						// Cgp[^Zbg
extern	int		Graphics_Hardware_Light_SetEnable_PF( int LightNumber, int EnableState ) ;								// Cg̗LAύX












// ˑVhE}bv֌W
extern	int		Graphics_Hardware_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;		// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap ) ;								// VhE}bvf[^ɕKvȃeNX`
extern	void	Graphics_Hardware_ShadowMap_RefreshVSParam_PF( void ) ;													// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_ShadowMap_RefreshPSParam_PF( void ) ;													// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	int		Graphics_Hardware_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap ) ;									// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap ) ;									// VhE}bvւ̕`I
extern	int		Graphics_Hardware_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap ) ;						// `ŎgpVhE}bvw肷AXbg͂OPw\@










// ˑVF[_[֌W
extern	int		Graphics_Hardware_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread ) ;		// VF[_[nh
extern	int		Graphics_Hardware_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader ) ;																			// VF[_[nȟn
extern	int		Graphics_Hardware_Shader_GetValidShaderVersion_PF( void ) ;																							// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_Shader_GetConstIndex_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_Shader_GetConstCount_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̐擾
extern	const FLOAT4 *Graphics_Hardware_Shader_GetConstDefaultParamF_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;									// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	int		Graphics_Hardware_Shader_SetConst_PF(   int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;		// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;											// ẅ̃VF[_[萔Zbg
#ifndef DX_NON_MODEL
extern	int		Graphics_Hardware_Shader_ModelCode_Init_PF( void ) ;																								// Rcfp̃VF[_[R[h̏s
#endif // DX_NON_MODEL










// ˑVF[_[p萔obt@֌W
extern	int		Graphics_Hardware_ShaderConstantBuffer_Create_PF( int ShaderConstantBufferHandle, int BufferSize, int ASyncThread ) ;												// VF[_[p萔obt@nh
extern	int		Graphics_Hardware_ShaderConstantBuffer_TerminateHandle_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;													// VF[_[p萔obt@nȟn
extern	void *	Graphics_Hardware_ShaderConstantBuffer_GetBuffer_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;														// VF[_[p萔obt@nh̒萔obt@̃AhX擾
extern	int		Graphics_Hardware_ShaderConstantBuffer_Update_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;															// VF[_[p萔obt@nh̒萔obt@ւ̕ύXKp
extern	int		Graphics_Hardware_ShaderConstantBuffer_Set_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer, int TargetShader /* DX_SHADERTYPE_VERTEX Ȃ */, int Slot ) ;	// VF[_[p萔obt@nh̒萔obt@w̃VF[_[̎w̃XbgɃZbg











// ˑ`֌W
extern	int		Graphics_Hardware_RenderVertex( int ASyncThread = FALSE ) ;																							// _obt@ɗ܂_f[^_O

extern	int		Graphics_Hardware_DrawBillboard3D_PF(     VECTOR Pos, float cx, float cy, float Size, float Angle,                                    IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_Hardware_DrawModiBillboard3D_PF( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag,               int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_Hardware_DrawGraph_PF(           int x,  int y, float xf, float yf,                                                          IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_Hardware_DrawExtendGraph_PF(     int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f,                 IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_Hardware_DrawRotaGraph_PF(       int x,  int y, float xf, float yf, double ExRate, double Angle,                             IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag ) ;	// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_Hardware_DrawModiGraph_PF(       int   x1, int   y1, int   x2, int   y2, int   x3, int   y3, int   x4, int   y4,             IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;		// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_Hardware_DrawModiGraphF_PF(      float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4,             IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;		// n[hEGAANZ[^gp DrawModiGraphF
extern	int		Graphics_Hardware_DrawSimpleTwoTriangleGraphF_PF( const GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_PARAM *Param,						  IMAGEDATA *Image, IMAGEDATA *BlendImage ) ;											// n[hEGAANZ[^gp DrawSimpleTwoTriangleGraphF

extern	int		Graphics_Hardware_DrawFillBox_PF(          int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;																// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_Hardware_DrawLineBox_PF(          int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;																// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_Hardware_DrawLine_PF(             int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;																// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_Hardware_DrawLine3D_PF(           VECTOR Pos1, VECTOR Pos2,                                       unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;					// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_Hardware_DrawCircle_Thickness_PF( int x, int y, int r,                                            unsigned int Color, int Thickness ) ;												// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_Hardware_DrawOval_Thickness_PF(   int x, int y, int rx, int ry,                                   unsigned int Color, int Thickness ) ;												// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_Hardware_DrawCircle_PF(           int x, int y, int r,                                            unsigned int Color, int FillFlag ) ;												// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_Hardware_DrawOval_PF(             int x, int y, int rx, int ry,                                   unsigned int Color, int FillFlag ) ;												// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_Hardware_DrawTriangle_PF(         int x1, int y1, int x2, int y2, int x3, int y3,                 unsigned int Color, int FillFlag ) ;												// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_Hardware_DrawTriangle3D_PF(       VECTOR Pos1, VECTOR Pos2, VECTOR Pos3,                          unsigned int Color, int FillFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_Hardware_DrawQuadrangle_PF(       int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag ) ;												// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_Hardware_DrawPixel_PF(            int x,  int y,                                                  unsigned int Color ) ;																// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_Hardware_DrawPixel3D_PF(          VECTOR Pos,                                                     unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;					// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_Hardware_DrawPixelSet_PF(         const POINTDATA *PointData, int Num ) ;																				// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_Hardware_DrawLineSet_PF(          const LINEDATA  *LineData,  int Num ) ;																				// n[hEGAANZ[^gp DrawLineSet

extern	int		Graphics_Hardware_DrawPrimitive_PF(                             const VERTEX_3D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawIndexedPrimitive_PF(                      const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawPrimitiveLight_PF(                        const VERTEX3D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawIndexedPrimitiveLight_PF(                 const VERTEX3D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawPrimitiveLight_UseVertexBuffer_PF(        VERTEXBUFFERHANDLEDATA *VertexBuffer,                                      int PrimitiveType,                 int StartVertex, int UseVertexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawIndexedPrimitiveLight_UseVertexBuffer_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer,  int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_Hardware_DrawPrimitive2D_PF(                                 VERTEX_2D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_Hardware_DrawPrimitive2DUser_PF(                       const VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_Hardware_DrawIndexedPrimitive2DUser_PF(                const VERTEX2D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;

extern	int		Graphics_Hardware_DrawPolygon3DToShader_PF(          const VERTEX3DSHADER *Vertex, int PolygonNum ) ;																										// VF[_[gĂRc|S`悷
extern	int		Graphics_Hardware_DrawPolygonIndexed3DToShader_PF(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum ) ;														// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPrimitive2DToShader_PF(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_Hardware_DrawPrimitive3DToShader_PF(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_Hardware_DrawPrimitiveIndexed2DToShader_PF( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed3DToShader_PF( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷( _CfbNXgp )

extern	int		Graphics_Hardware_DrawPrimitive3DToShader_UseVertexBuffer2_PF(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2_PF( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )

extern	int		Graphics_Hardware_Paint_PF( int x, int y, unsigned int FillColor, ULONGLONG BoundaryColor ) ;			// w_狫EFƂ܂œhԂ











// wchar_tŊ֐
extern	int			LoadBmpToGraph_WCHAR_T(			const wchar_t *FileName, int TextureFlag, int ReverseFlag, int SurfaceMode = DX_MOVIESURFACE_NORMAL ) ;
extern	int			LoadGraph_WCHAR_T(				const wchar_t *FileName, int NotUse3DFlag = FALSE ) ;
extern	int			LoadReverseGraph_WCHAR_T(		const wchar_t *FileName, int NotUse3DFlag = FALSE ) ;
extern	int			LoadDivGraph_WCHAR_T(			const wchar_t *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf, int NotUse3DFlag = FALSE ) ;
extern	int			LoadDivBmpToGraph_WCHAR_T(		const wchar_t *FileName, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag ) ;
extern	int			LoadReverseDivGraph_WCHAR_T(	const wchar_t *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf, int NotUse3DFlag = FALSE ) ;
extern	int			LoadBlendGraph_WCHAR_T(			const wchar_t *FileName ) ;
#ifdef __WINDOWS__
extern	int			LoadGraphToResource_WCHAR_T(	const wchar_t *ResourceName, const wchar_t *ResourceType ) ;
extern	int			LoadDivGraphToResource_WCHAR_T(	const wchar_t *ResourceName, const wchar_t *ResourceType, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf ) ;
#endif // __WINDOWS__
extern	int			ReloadGraph_WCHAR_T(			const wchar_t *FileName, int GrHandle, int ReverseFlag = FALSE ) ;
extern	int			ReloadDivGraph_WCHAR_T(			const wchar_t *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, const int *HandleBuf, int ReverseFlag = FALSE ) ;
extern	int			ReloadReverseGraph_WCHAR_T(		const wchar_t *FileName, int GrHandle ) ;
extern	int			ReloadReverseDivGraph_WCHAR_T(	const wchar_t *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, const int *HandleBuf ) ;

extern	int			GetGraphFilePath_WCHAR_T(		int GrHandle, wchar_t *FilePathBuffer ) ;

extern	int			LoadGraphScreen_WCHAR_T(        int x, int y, const wchar_t *GraphName, int TransFlag ) ;

extern	int			SaveDrawScreen_WCHAR_T(			int x1, int y1, int x2, int y2, const wchar_t *FileName, int SaveType = DX_IMAGESAVETYPE_BMP , int Jpeg_Quality = 80 , int Jpeg_Sample2x1 = TRUE , int Png_CompressionLevel = -1 ) ;
extern	int			SaveDrawScreenToBMP_WCHAR_T(	int x1, int y1, int x2, int y2, const wchar_t *FileName ) ;
extern	int			SaveDrawScreenToJPEG_WCHAR_T(	int x1, int y1, int x2, int y2, const wchar_t *FileName, int Quality = 80 , int Sample2x1 = TRUE ) ;
extern	int			SaveDrawScreenToPNG_WCHAR_T(	int x1, int y1, int x2, int y2, const wchar_t *FileName, int CompressionLevel = -1 ) ;

extern	int			LoadVertexShader_WCHAR_T(		const wchar_t *FileName ) ;
extern	int			LoadPixelShader_WCHAR_T(		const wchar_t *FileName ) ;

extern	int			GetConstIndexToShader_WCHAR_T(           const wchar_t *ConstantName, int ShaderHandle ) ;
extern	int			GetConstCountToShader_WCHAR_T(           const wchar_t *ConstantName, int ShaderHandle ) ;
extern	const FLOAT4 *GetConstDefaultParamFToShader_WCHAR_T( const wchar_t *ConstantName, int ShaderHandle ) ;

extern	int			PlayMovie_WCHAR_T(						const wchar_t *FileName, int ExRate, int PlayType ) ;
extern	int			OpenMovieToGraph_WCHAR_T(				const wchar_t *FileName, int FullColor = TRUE ) ;



#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXGRAPHICS_H__


